## ros-foxy-maliput-viz 0.1.1

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_viz LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)

find_package(ignition-gui3 REQUIRED)
find_package(maliput REQUIRED)
find_package(yaml-cpp REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

ament_environment_hooks(
  "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
)

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
    ament_doxygen_generate(doxygen_maliput_viz
      CONFIG_OVERLAY doc/Doxyfile.overlay.in
      TEST_ON_WARNS
    )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Export
##############################################################################

ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.dsv.in")
ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.sh.in")

ament_export_dependencies(ament_cmake)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)

ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(maliput_viz)

=== src/maliput_viz/CMakeLists.txt ===
add_subdirectory(application)
add_subdirectory(config)
add_subdirectory(flags)
add_subdirectory(plugins)
add_subdirectory(resources)
add_subdirectory(tools)

=== src/maliput_viz/application/CMakeLists.txt ===
add_executable(maliput_viz
  maliput_viz.cc
)

target_link_libraries(maliput_viz
  ignition-common3::ignition-common3
  ignition-gui3::ignition-gui3
  maliput_viz::flags
  ${Qt5Core_LIBRARIES}
  ${Qt5Widgets_LIBRARIES}
)

target_include_directories(maliput_viz
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)

install(
  TARGETS maliput_viz
  EXPORT ${PROJECT_NAME}-targets
  DESTINATION bin
)

=== src/maliput_viz/config/CMakeLists.txt ===
# Install .config files.
install(
  FILES
    maliput_viz_layout.config
  DESTINATION
    share/${PROJECT_NAME}/layouts
)

=== src/maliput_viz/flags/CMakeLists.txt ===
add_library(flags
  gflags.cc
)

add_library(maliput_viz::flags ALIAS flags)
set_target_properties(flags
  PROPERTIES
    OUTPUT_NAME maliput_viz_flags
)

target_link_libraries(flags
  gflags
  maliput::common
)

target_include_directories(flags
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)

install(
  TARGETS flags
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/maliput_viz/plugins/CMakeLists.txt ===
include_directories(
  ${Qt5Core_INCLUDE_DIRS}
)

# ----------------------------------------
# maliput_viewer_model library.
add_library(maliput_viewer_model
  maliput_viewer_model.cc
  maliput_mesh_converter.cc
)
add_library(maliput_viz::maliput_viewer_model ALIAS maliput_viewer_model)
set_target_properties(maliput_viewer_model
  PROPERTIES
    OUTPUT_NAME maliput_viz_maliput_viewer_model
)

target_link_libraries(maliput_viewer_model
  ${drake_LIBRARIES}
  ignition-common3::ignition-common3
  ignition-rendering3::ignition-rendering3
  maliput::api
  maliput::utility
)

install(
  TARGETS maliput_viewer_model
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

# ----------------------------------------
# arrow_mesh library.
add_library(arrow_mesh
  arrow_mesh.cc
)
add_library(maliput_viz::arrow_mesh ALIAS arrow_mesh)
set_target_properties(arrow_mesh
  PROPERTIES
    OUTPUT_NAME maliput_viz_arrow_mesh
)

target_link_libraries(arrow_mesh
  ${drake_LIBRARIES}
  ignition-common3::ignition-common3
  ignition-math6::ignition-math6
  ignition-rendering3::ignition-rendering3
)

install(
  TARGETS arrow_mesh
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

# ----------------------------------------
# selector library.
add_library(selector
  selector.cc
)
add_library(maliput_viz::selector ALIAS selector)
set_target_properties(selector
  PROPERTIES
    OUTPUT_NAME maliput_viz_selector
)

target_link_libraries(selector
  ignition-common3::ignition-common3
  ignition-math6::ignition-math6
  ignition-rendering3::ignition-rendering3
  maliput::api
)

install(
  TARGETS selector
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

# ----------------------------------------
# traffic light manager library.
add_library(traffic_light_manager
  traffic_light_manager.cc
)
add_library(maliput_viz::traffic_light_manager ALIAS traffic_light_manager)
set_target_properties(traffic_light_manager
  PROPERTIES
    OUTPUT_NAME maliput_viz_traffic_light_manager
)

target_link_libraries(traffic_light_manager
  ignition-common3::ignition-common3
  ignition-math6::ignition-math6
  ignition-rendering3::ignition-rendering3
  maliput::api
)

install(
  TARGETS traffic_light_manager
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

#-------------------------------------------------------------------------------
# maliput_backend_selection (Qt Object)
QT5_WRAP_CPP(maliput_backend_selection_headers_MOC maliput_backend_selection.hh)

add_library(maliput_backend_selection
  ${CMAKE_CURRENT_SOURCE_DIR}/maliput_backend_selection.cc
  ${maliput_backend_selection_headers_MOC}
  ${maliput_backend_selection_RCC}
)
add_library(maliput_viz::maliput_backend_selection ALIAS maliput_backend_selection)
set_target_properties(maliput_backend_selection
  PROPERTIES
    OUTPUT_NAME maliput_backend_selection
)
target_link_libraries(maliput_backend_selection
    maliput_viz::maliput_viewer_model
    maliput::plugin
    ignition-gui3::ignition-gui3
    ignition-common3::ignition-common3
    ignition-transport8::ignition-transport8
    ignition-rendering3::ignition-rendering3
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
)

install(
  TARGETS maliput_backend_selection
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

#-------------------------------------------------------------------------------
# MaliputViewerPlugin (ign-gui 3)
QT5_WRAP_CPP(MaliputViewerPlugin_headers_MOC maliput_viewer_plugin.hh)
QT5_ADD_RESOURCES(MaliputViewerPlugin_RCC maliput_viewer_plugin.qrc)

add_library(MaliputViewerPlugin
  ${CMAKE_CURRENT_SOURCE_DIR}/maliput_viewer_plugin.cc
  ${maliput_backend_selection_headers_MOC}
  ${MaliputViewerPlugin_headers_MOC}
  ${MaliputViewerPlugin_RCC}
)
add_library(maliput_viz::MaliputViewerPlugin ALIAS MaliputViewerPlugin)
set_target_properties(MaliputViewerPlugin
  PROPERTIES
    OUTPUT_NAME MaliputViewerPlugin
)

target_link_libraries(MaliputViewerPlugin
    maliput_viz::arrow_mesh
    maliput_viz::flags
    maliput_viz::maliput_backend_selection
    maliput_viz::maliput_viewer_model
    maliput_viz::selector
    maliput_viz::tools
    maliput_viz::traffic_light_manager
    ignition-gui3::ignition-gui3
    ignition-common3::ignition-common3
    ignition-transport8::ignition-transport8
    ignition-rendering3::ignition-rendering3
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ignition-plugin1::register
)

install(
  TARGETS MaliputViewerPlugin
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib/gui_plugins
  ARCHIVE DESTINATION lib/gui_plugins
)

=== src/maliput_viz/resources/CMakeLists.txt ===
install(
  FILES
    arrow_bulb.obj
    arrow_bulb.mtl
  DESTINATION
    share/${PROJECT_NAME}/resources
)

=== src/maliput_viz/tools/CMakeLists.txt ===
add_library(tools
  yaml_parser.cc
)

add_library(maliput_viz::tools ALIAS tools)
set_target_properties(tools
  PROPERTIES
    OUTPUT_NAME tools
)

target_link_libraries(tools
  maliput::common
  yaml-cpp
)

target_include_directories(tools
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)

install(
  TARGETS tools
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== debian/changelog ===
ros-foxy-maliput-viz (0.1.1-1focal) focal; urgency=high

  * Evolves dependency tag to <depend> for the ignition-gui3 package. (#22 <https://github.com/maliput/maliput_viz/issues/22>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 13 Mar 2023 03:00:00 -0000

ros-foxy-maliput-viz (0.1.0-1focal) focal; urgency=high

  * Adds command line support for the maliput viz app. (#18 <https://github.com/maliput/maliput_viz/issues/18>)
  * Fills edition boxes when a parameter is clicked. (#17 <https://github.com/maliput/maliput_viz/issues/17>)
  * Uses env hooks instead of compiled paths. (#10 <https://github.com/maliput/maliput_viz/issues/10>)
  * Updates README file. (#6 <https://github.com/maliput/maliput_viz/issues/6>)
  * Adds missing doxygen file. (#8 <https://github.com/maliput/maliput_viz/issues/8>)
  * Bring maliput_viewer application from delphyne_gui (#1 <https://github.com/maliput/maliput_viz/issues/1>)
  * Initial commit
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 13 Dec 2022 03:00:00 -0000

=== debian/control ===
Source: ros-foxy-maliput-viz
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), libignition-gui3-dev, libyaml-cpp-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-maliput, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-viz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libignition-gui3-dev, libyaml-cpp-dev, ros-foxy-maliput, ros-foxy-ros-workspace
Description: Maliput visualizer

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-viz//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
